GraphicsMagick

- Home
- Project
- Download
- Install
- Source
- News
- Utilities
- Programming
- Reference

# draw

User-friendly methods to draw on an image

# DrawAnnotation

## Synopsis

    void DrawAnnotation( DrawContext context, const double x, const double y,
                         const unsigned char *text );

## Description

DrawAnnotation() draws text on the image.

The format of the DrawAnnotation method is:

    void DrawAnnotation( DrawContext context, const double x, const double y,
                         const unsigned char *text );

context:

  drawing context

x:

  x ordinate to left of text

y:

  y ordinate to text baseline

text:

  text to draw

# DrawAffine

## Synopsis

    void DrawAffine( DrawContext context, const AffineMatrix *affine );

## Description

DrawAffine() adjusts the current affine transformation matrix with the specified affine transformation matrix. Note that the current affine transform is adjusted rather than replaced.

The format of the DrawAffine method is:

    void DrawAffine( DrawContext context, const AffineMatrix *affine );

A description of each parameter follows:

context:

  Drawing context

affine:

  Affine matrix parameters

# DrawAllocateContext

## Synopsis

    DrawContext DrawAllocateContext( const DrawInfo *draw_info, Image *image );

## Description

DrawAllocateContext() allocates an initial drawing context which is an opaque handle required by the remaining drawing methods.

The format of the DrawAllocateContext method is:

    DrawContext DrawAllocateContext( const DrawInfo *draw_info, Image *image );

draw_info:

  Initial drawing defaults. Set to NULL to use GraphicsMagick defaults.

image:

  The image to draw on.

# DrawArc

## Synopsis

    void DrawArc( DrawContext context, const double sx, const double sy, const double ex,
                  const double ey, const double sd, const double ed );

## Description

DrawArc() draws an arc falling within a specified bounding rectangle on the image.

The format of the DrawArc method is:

    void DrawArc( DrawContext context, const double sx, const double sy, const double ex,
                  const double ey, const double sd, const double ed );

context:

  drawing context

sx:

  starting x ordinate of bounding rectangle

sy:

  starting y ordinate of bounding rectangle

ex:

  ending x ordinate of bounding rectangle

ey:

  ending y ordinate of bounding rectangle

sd:

  starting degrees of rotation

ed:

  ending degrees of rotation

# DrawBezier

## Synopsis

    void DrawBezier( DrawContext context, const unsigned long num_coords,
                     const PointInfo *coordinates );

## Description

DrawBezier() draws a bezier curve through a set of points on the image.

The format of the DrawBezier method is:

    void DrawBezier( DrawContext context, const unsigned long num_coords,
                     const PointInfo *coordinates );

context:

  drawing context

num_coords:

  number of coordinates

coordinates:

  coordinates

# DrawCircle

## Synopsis

    void DrawCircle( DrawContext context, const double ox, const double oy, const double px,
                     const double py );

## Description

DrawCircle() draws a circle on the image.

The format of the DrawCircle method is:

    void DrawCircle( DrawContext context, const double ox, const double oy, const double px,
                     const double py );

context:

  drawing context

ox:

  origin x ordinate

oy:

  origin y ordinate

px:

  perimeter x ordinate

py:

  perimeter y ordinate

# DrawGetClipPath

## Synopsis

    char *DrawGetClipPath( DrawContext context );

## Description

DrawGetClipPath() obtains the current clipping path ID. The value returned must be deallocated by the user when it is no longer needed.

The format of the DrawGetClipPath method is:

    char *DrawGetClipPath( DrawContext context );

A description of each parameter follows:

context:

  drawing context

# DrawSetClipPath

## Synopsis

    void DrawSetClipPath( DrawContext context, const char *clip_path );

## Description

DrawSetClipPath() associates a named clipping path with the image. Only the areas drawn on by the clipping path will be modified as long as it remains in effect.

The format of the DrawSetClipPath method is:

    void DrawSetClipPath( DrawContext context, const char *clip_path );

A description of each parameter follows:

context:

  drawing context

clip_path:

  name of clipping path to associate with image

# DrawGetClipRule

## Synopsis

    FillRule DrawGetClipRule( DrawContext context );

## Description

DrawGetClipRule() returns the current polygon fill rule to be used by the clipping path.

The format of the DrawGetClipRule method is:

    FillRule DrawGetClipRule( DrawContext context );

A description of each parameter follows:

context:

  drawing context

# DrawSetClipRule

## Synopsis

    void DrawSetClipRule( DrawContext context, const FillRule fill_rule );

## Description

DrawSetClipRule() set the polygon fill rule to be used by the clipping path.

The format of the DrawSetClipRule method is:

    void DrawSetClipRule( DrawContext context, const FillRule fill_rule );

context:

  drawing context

fill_rule:

  fill rule (EvenOddRule or NonZeroRule)

# DrawGetClipUnits

## Synopsis

    ClipPathUnits DrawGetClipUnits( DrawContext context );

## Description

DrawGetClipUnits() returns the interpretation of clip path units.

The format of the DrawGetClipUnits method is:

    ClipPathUnits DrawGetClipUnits( DrawContext context );

A description of each parameter follows:

context:

  drawing context

# DrawSetClipUnits

## Synopsis

    void DrawSetClipUnits( DrawContext context, const ClipPathUnits clip_units );

## Description

DrawSetClipUnits() sets the interpretation of clip path units.

The format of the DrawSetClipUnits method is:

    void DrawSetClipUnits( DrawContext context, const ClipPathUnits clip_units );

context:

  drawing context

clip_units:

  units to use (UserSpace, UserSpaceOnUse, or ObjectBoundingBox)

# DrawColor

## Synopsis

    void DrawColor( DrawContext context, const double x, const double y,
                    const PaintMethod paintMethod );

## Description

DrawColor() draws color on image using the current fill color, starting at specified position, and using specified paint method. The available paint methods are:

PointMethod: Recolors the target pixel ReplaceMethod: Recolor any pixel that matches the target pixel. FloodfillMethod: Recolors target pixels and matching neighbors. FillToBorderMethod: Recolor target pixels and neighbors not matching border color. ResetMethod: Recolor all pixels.

The format of the DrawColor method is:

    void DrawColor( DrawContext context, const double x, const double y,
                    const PaintMethod paintMethod );

context:

  drawing context

x:

  x ordinate

y:

  y ordinate

paintMethod:

  paint method

# DrawComment

## Synopsis

    void DrawComment( DrawContext context, const char *comment );

## Description

DrawComment() adds a comment to a vector output stream.

The format of the DrawComment method is:

    void DrawComment( DrawContext context, const char *comment );

A description of each parameter follows:

context:

  drawing context

comment:

  comment text

# DrawDestroyContext

## Synopsis

    void DrawDestroyContext( DrawContext context );

## Description

DrawDestroyContext() frees all resources associated with the drawing context. Once the drawing context has been freed, it should not be used any further unless it re-allocated.

The format of the DrawDestroyContext method is:

    void DrawDestroyContext( DrawContext context );

A description of each parameter follows:

context:

  drawing context to destroy

# DrawEllipse

## Synopsis

    void DrawEllipse( DrawContext context, const double ox, const double oy, const double rx,
                      const double ry, const double start, const double end );

## Description

DrawEllipse() draws an ellipse on the image.

The format of the DrawEllipse method is:

    void DrawEllipse( DrawContext context, const double ox, const double oy, const double rx,
                      const double ry, const double start, const double end );

context:

  drawing context

ox:

  origin x ordinate

oy:

  origin y ordinate

rx:

  radius in x

ry:

  radius in y

start:

  starting rotation in degrees

end:

  ending rotation in degrees

# DrawGetFillColor

## Synopsis

    PixelPacket DrawGetFillColor( DrawContext context );

## Description

DrawGetFillColor() returns the fill color used for drawing filled objects.

The format of the DrawGetFillColor method is:

    PixelPacket DrawGetFillColor( DrawContext context );

A description of each parameter follows:

context:

  drawing context

# DrawSetFillColor

## Synopsis

    void DrawSetFillColor( DrawContext context, const PixelPacket *fill_color );

## Description

DrawSetFillColor() sets the fill color to be used for drawing filled objects.

The format of the DrawSetFillColor method is:

    void DrawSetFillColor( DrawContext context, const PixelPacket *fill_color );

context:

  drawing context

fill_color:

  fill color

# DrawSetFillColorString

## Synopsis

    void DrawSetFillColorString( DrawContext context, const char *fill_color );

## Description

DrawSetFillColorString() sets the fill color to be used for drawing filled objects.

The format of the DrawSetFillColorString method is:

    void DrawSetFillColorString( DrawContext context, const char *fill_color );

A description of each parameter follows:

context:

  drawing context

fill_color:

  fill color

# DrawSetFillPatternURL

## Synopsis

    void DrawSetFillPatternURL( DrawContext context, const char *fill_url );

## Description

DrawSetFillPatternURL() sets the URL to use as a fill pattern for filling objects. Only local URLs ("#identifier") are supported at this time. These local URLs are normally created by defining a named fill pattern with DrawPushPattern/DrawPopPattern.

The format of the DrawSetFillPatternURL method is:

    void DrawSetFillPatternURL( DrawContext context, const char *fill_url );

A description of each parameter follows:

context:

  drawing context

fill_url:

  URL to use to obtain fill pattern.

# DrawGetFillOpacity

## Synopsis

    double DrawGetFillOpacity( DrawContext context );

## Description

DrawGetFillOpacity() returns the opacity used when drawing using the fill color or fill texture. Fully opaque is 1.0.

The format of the DrawGetFillOpacity method is:

    double DrawGetFillOpacity( DrawContext context );

A description of each parameter follows:

context:

  drawing context

# DrawSetFillOpacity

## Synopsis

    void DrawSetFillOpacity( DrawContext context, const double fill_opacity );

## Description

DrawSetFillOpacity() sets the opacity to use when drawing using the fill color or fill texture. Fully opaque is 1.0.

The format of the DrawSetFillOpacity method is:

    void DrawSetFillOpacity( DrawContext context, const double fill_opacity );

A description of each parameter follows:

context:

  drawing context

fill_opacity:

  fill opacity

# DrawGetFillRule

## Synopsis

    FillRule DrawGetFillRule( DrawContext context );

## Description

DrawGetFillRule() returns the fill rule used while drawing polygons.

The format of the DrawGetFillRule method is:

    FillRule DrawGetFillRule( DrawContext context );

A description of each parameter follows:

context:

  drawing context

# DrawSetFillRule

## Synopsis

    void DrawSetFillRule( DrawContext context, const FillRule fill_rule );

## Description

DrawSetFillRule() sets the fill rule to use while drawing polygons.

The format of the DrawSetFillRule method is:

    void DrawSetFillRule( DrawContext context, const FillRule fill_rule );

A description of each parameter follows:

context:

  drawing context

fill_rule:

  fill rule (EvenOddRule or NonZeroRule)

# DrawGetFont

## Synopsis

    char *DrawGetFont( DrawContext context );

## Description

DrawGetFont() returns a null-terminaged string specifying the font used when annotating with text. The value returned must be freed by the user when no longer needed.

The format of the DrawGetFont method is:

    char *DrawGetFont( DrawContext context );

A description of each parameter follows:

context:

  drawing context

# DrawSetFont

## Synopsis

    void DrawSetFont( DrawContext context, const char *font_name );

## Description

DrawSetFont() sets the fully-sepecified font to use when annotating with text.

The format of the DrawSetFont method is:

    void DrawSetFont( DrawContext context, const char *font_name );

A description of each parameter follows:

context:

  drawing context

font_name:

  font name

# DrawGetFontFamily

## Synopsis

    char *DrawGetFontFamily( DrawContext context );

## Description

DrawGetFontFamily() returns the font family to use when annotating with text. The value returned must be freed by the user when it is no longer needed.

The format of the DrawGetFontFamily method is:

    char *DrawGetFontFamily( DrawContext context );

A description of each parameter follows:

context:

  drawing context

# DrawSetFontFamily

## Synopsis

    void DrawSetFontFamily( DrawContext context, const char *font_family );

## Description

DrawSetFontFamily() sets the font family to use when annotating with text.

The format of the DrawSetFontFamily method is:

    void DrawSetFontFamily( DrawContext context, const char *font_family );

A description of each parameter follows:

context:

  drawing context

font_family:

  font family

# DrawGetFontSize

## Synopsis

    double DrawGetFontSize( DrawContext context );

## Description

DrawGetFontSize() returns the font pointsize used when annotating with text.

The format of the DrawGetFontSize method is:

    double DrawGetFontSize( DrawContext context );

A description of each parameter follows:

context:

  drawing context

# DrawSetFontSize

## Synopsis

    void DrawSetFontSize( DrawContext context, const double pointsize );

## Description

DrawSetFontSize() sets the font pointsize to use when annotating with text.

The format of the DrawSetFontSize method is:

    void DrawSetFontSize( DrawContext context, const double pointsize );

A description of each parameter follows:

context:

  drawing context

pointsize:

  text pointsize

# DrawGetFontStretch

## Synopsis

    StretchType DrawGetFontStretch( DrawContext context );

## Description

DrawGetFontStretch() returns the font stretch used when annotating with text.

The format of the DrawGetFontStretch method is:

    StretchType DrawGetFontStretch( DrawContext context );

A description of each parameter follows:

context:

  drawing context

# DrawSetFontStretch

## Synopsis

    void DrawSetFontStretch( DrawContext context, const StretchType font_stretch );

## Description

DrawSetFontStretch() sets the font stretch to use when annotating with text. The AnyStretch enumeration acts as a wild-card "don't care" option.

The format of the DrawSetFontStretch method is:

    void DrawSetFontStretch( DrawContext context, const StretchType font_stretch );

context:

  drawing context

font_stretch:

  font stretch (NormalStretch, UltraCondensedStretch, CondensedStretch, SemiCondensedStretch, SemiExpandedStretch, ExpandedStretch, ExtraExpandedStretch, UltraExpandedStretch, AnyStretch)

# DrawGetFontStyle

## Synopsis

    StyleType DrawGetFontStyle( DrawContext context );

## Description

DrawGetFontStyle() returns the font style used when annotating with text.

The format of the DrawGetFontStyle method is:

    StyleType DrawGetFontStyle( DrawContext context );

A description of each parameter follows:

context:

  drawing context

# DrawSetFontStyle

## Synopsis

    void DrawSetFontStyle( DrawContext context, const StyleType style );

## Description

DrawSetFontStyle() sets the font style to use when annotating with text. The AnyStyle enumeration acts as a wild-card "don't care" option.

The format of the DrawSetFontStyle method is:

    void DrawSetFontStyle( DrawContext context, const StyleType style );

A description of each parameter follows:

context:

  drawing context

style:

  font style (NormalStyle, ItalicStyle, ObliqueStyle, AnyStyle)

# DrawGetFontWeight

## Synopsis

    unsigned long DrawGetFontWeight( DrawContext context );

## Description

DrawGetFontWeight() returns the font weight used when annotating with text.

The format of the DrawGetFontWeight method is:

    unsigned long DrawGetFontWeight( DrawContext context );

A description of each parameter follows:

context:

  drawing context

# DrawSetFontWeight

## Synopsis

    void DrawSetFontWeight( DrawContext context, const unsigned long font_weight );

## Description

DrawSetFontWeight() sets the font weight to use when annotating with text.

The format of the DrawSetFontWeight method is:

    void DrawSetFontWeight( DrawContext context, const unsigned long font_weight );

context:

  drawing context

font_weight:

  font weight (valid range 100-900)

# DrawGetGravity

## Synopsis

    GravityType DrawGetGravity( DrawContext context );

## Description

DrawGetGravity() returns the text placement gravity used when annotating with text.

The format of the DrawGetGravity method is:

    GravityType DrawGetGravity( DrawContext context );

A description of each parameter follows:

context:

  drawing context

# DrawSetGravity

## Synopsis

    void DrawSetGravity( DrawContext context, const GravityType gravity );

## Description

DrawSetGravity() sets the text placement gravity to use when annotating with text.

The format of the DrawSetGravity method is:

    void DrawSetGravity( DrawContext context, const GravityType gravity );

A description of each parameter follows:

context:

  drawing context

gravity:

  positioning gravity (NorthWestGravity, NorthGravity, NorthEastGravity, WestGravity, CenterGravity, EastGravity, SouthWestGravity, SouthGravity, SouthEastGravity)

# DrawComposite

## Synopsis

    void DrawComposite( DrawContext context, const CompositeOperator composite_operator,
                        const double x, const double y, const double width, const double height,
                        const Image *image );

## Description

DrawComposite() composites an image onto the current image, using the specified composition operator, specified position, and at the specified size.

The format of the DrawComposite method is:

    void DrawComposite( DrawContext context, const CompositeOperator composite_operator,
                        const double x, const double y, const double width, const double height,
                        const Image *image );

context:

  drawing context

composite_operator:

  composition operator

x:

  x ordinate of top left corner

y:

  y ordinate of top left corner

width:

  Width to resize image to prior to compositing. Specify zero to use existing width.

height:

  Height to resize image to prior to compositing. Specify zero to use existing height.

image:

  Image to composite

# DrawLine

## Synopsis

    void DrawLine( DrawContext context, const double sx, const double sy, const double ex,
                   const double ey );

## Description

DrawLine() draws a line on the image using the current stroke color, stroke opacity, and stroke width.

The format of the DrawLine method is:

    void DrawLine( DrawContext context, const double sx, const double sy, const double ex,
                   const double ey );

context:

  drawing context

sx:

  starting x ordinate

sy:

  starting y ordinate

ex:

  ending x ordinate

ey:

  ending y ordinate

# DrawMatte

## Synopsis

    void DrawMatte( DrawContext context, const double x, const double y,
                    const PaintMethod paint_method );

## Description

DrawMatte() paints on the image's opacity channel in order to set effected pixels to transparent. The available paint methods are:

PointMethod: Select the target pixel ReplaceMethod: Select any pixel that matches the target pixel. FloodfillMethod: Select the target pixel and matching neighbors. FillToBorderMethod: Select the target pixel and neighbors not matching border color. ResetMethod: Select all pixels.

The format of the DrawMatte method is:

    void DrawMatte( DrawContext context, const double x, const double y,
                    const PaintMethod paint_method );

context:

  drawing context

x:

  x ordinate

y:

  y ordinate

o paint_method:

# DrawPathClose

## Synopsis

    void DrawPathClose( DrawContext context );

## Description

DrawPathClose() adds a path element to the current path which closes the current subpath by drawing a straight line from the current point to the current subpath's most recent starting point (usually, the most recent moveto point).

The format of the DrawPathClose method is:

    void DrawPathClose( DrawContext context );

A description of each parameter follows:

context:

  drawing context

# DrawPathCurveToAbsolute

## Synopsis

    void DrawPathCurveToAbsolute( DrawContext context, const double x1, const double y1,
                                  const double x2, const double y2, const double x,
                                  const double y );

## Description

DrawPathCurveToAbsolute() draws a cubic Bezier curve from the current point to (x,y) using (x1,y1) as the control point at the beginning of the curve and (x2,y2) as the control point at the end of the curve using absolute coordinates. At the end of the command, the new current point becomes the final (x,y) coordinate pair used in the polybezier.

The format of the DrawPathCurveToAbsolute method is:

    void DrawPathCurveToAbsolute( DrawContext context, const double x1, const double y1,
                                  const double x2, const double y2, const double x,
                                  const double y );

context:

  drawing context

x1:

  x ordinate of control point for curve beginning

y1:

  y ordinate of control point for curve beginning

x2:

  x ordinate of control point for curve ending

y2:

  y ordinate of control point for curve ending

x:

  x ordinate of the end of the curve

y:

  y ordinate of the end of the curve

# DrawPathCurveToRelative

## Synopsis

    void DrawPathCurveToRelative( DrawContext context, const double x1, const double y1,
                                  const double x2, const double y2, const double x,
                                  const double y );

## Description

DrawPathCurveToRelative() draws a cubic Bezier curve from the current point to (x,y) using (x1,y1) as the control point at the beginning of the curve and (x2,y2) as the control point at the end of the curve using relative coordinates. At the end of the command, the new current point becomes the final (x,y) coordinate pair used in the polybezier.

The format of the DrawPathCurveToRelative method is:

    void DrawPathCurveToRelative( DrawContext context, const double x1, const double y1,
                                  const double x2, const double y2, const double x,
                                  const double y );

context:

  drawing context

x1:

  x ordinate of control point for curve beginning

y1:

  y ordinate of control point for curve beginning

x2:

  x ordinate of control point for curve ending

y2:

  y ordinate of control point for curve ending

x:

  x ordinate of the end of the curve

y:

  y ordinate of the end of the curve

# DrawPathCurveToQuadraticBezierAbsolute

## Synopsis

    void DrawPathCurveToQuadraticBezierAbsolute( DrawContext context, const double x1,
                                                 const double y1, const double x,
                                                 const double y );

## Description

DrawPathCurveToQuadraticBezierAbsolute() draws a quadratic Bezier curve from the current point to (x,y) using (x1,y1) as the control point using absolute coordinates. At the end of the command, the new current point becomes the final (x,y) coordinate pair used in the polybezier.

The format of the DrawPathCurveToQuadraticBezierAbsolute method is:

    void DrawPathCurveToQuadraticBezierAbsolute( DrawContext context, const double x1,
                                                 const double y1, const double x,
                                                 const double y );

context:

  drawing context

x1:

  x ordinate of the control point

y1:

  y ordinate of the control point

x:

  x ordinate of final point

y:

  y ordinate of final point

# DrawPathCurveToQuadraticBezierRelative

## Synopsis

    void DrawPathCurveToQuadraticBezierRelative( DrawContext context, const double x1,
                                                 const double y1, const double x,
                                                 const double y );

## Description

DrawPathCurveToQuadraticBezierRelative() draws a quadratic Bezier curve from the current point to (x,y) using (x1,y1) as the control point using relative coordinates. At the end of the command, the new current point becomes the final (x,y) coordinate pair used in the polybezier.

The format of the DrawPathCurveToQuadraticBezierRelative method is:

    void DrawPathCurveToQuadraticBezierRelative( DrawContext context, const double x1,
                                                 const double y1, const double x,
                                                 const double y );

context:

  drawing context

x1:

  x ordinate of the control point

y1:

  y ordinate of the control point

x:

  x ordinate of final point

y:

  y ordinate of final point

# DrawPathCurveToQuadraticBezierSmoothAbsolute

## Synopsis

    void DrawPathCurveToQuadraticBezierSmoothAbsolute( DrawContext context, const double x,
                                                       const double y );

## Description

DrawPathCurveToQuadraticBezierSmoothAbsolute() draws a quadratic Bezier curve (using absolute coordinates) from the current point to (x,y). The control point is assumed to be the reflection of the control point on the previous command relative to the current point. (If there is no previous command or if the previous command was not a DrawPathCurveToQuadraticBezierAbsolute, DrawPathCurveToQuadraticBezierRelative, DrawPathCurveToQuadraticBezierSmoothAbsolut or DrawPathCurveToQuadraticBezierSmoothRelative, assume the control point is coincident with the current point.). At the end of the command, the new current point becomes the final (x,y) coordinate pair used in the polybezier.

The format of the DrawPathCurveToQuadraticBezierSmoothAbsolute method is:

    void DrawPathCurveToQuadraticBezierSmoothAbsolute( DrawContext context, const double x,
                                                       const double y );

context:

  drawing context

x:

  x ordinate of final point

y:

  y ordinate of final point

# DrawPathCurveToQuadraticBezierSmoothRelative

## Synopsis

    void DrawPathCurveToQuadraticBezierSmoothRelative( DrawContext context, const double x,
                                                       const double y );

## Description

DrawPathCurveToQuadraticBezierSmoothAbsolute() draws a quadratic Bezier curve (using relative coordinates) from the current point to (x,y). The control point is assumed to be the reflection of the control point on the previous command relative to the current point. (If there is no previous command or if the previous command was not a DrawPathCurveToQuadraticBezierAbsolute, DrawPathCurveToQuadraticBezierRelative, DrawPathCurveToQuadraticBezierSmoothAbsolut or DrawPathCurveToQuadraticBezierSmoothRelative, assume the control point is coincident with the current point.). At the end of the command, the new current point becomes the final (x,y) coordinate pair used in the polybezier.

The format of the DrawPathCurveToQuadraticBezierSmoothRelative method is:

    void DrawPathCurveToQuadraticBezierSmoothRelative( DrawContext context, const double x,
                                                       const double y );

context:

  drawing context

x:

  x ordinate of final point

y:

  y ordinate of final point

# DrawPathCurveToSmoothAbsolute

## Synopsis

    void DrawPathCurveToSmoothAbsolute( DrawContext context, const double x2, const double y2,
                                        const double x, const double y );

## Description

DrawPathCurveToSmoothAbsolute() draws a cubic Bezier curve from the current point to (x,y) using absolute coordinates. The first control point is assumed to be the reflection of the second control point on the previous command relative to the current point. (If there is no previous command or if the previous command was not an DrawPathCurveToAbsolute, DrawPathCurveToRelative, DrawPathCurveToSmoothAbsolute or DrawPathCurveToSmoothRelative, assume the first control point is coincident with the current point.) (x2,y2) is the second control point (i.e., the control point at the end of the curve). At the end of the command, the new current point becomes the final (x,y) coordinate pair used in the polybezier.

The format of the DrawPathCurveToSmoothAbsolute method is:

    void DrawPathCurveToSmoothAbsolute( DrawContext context, const double x2, const double y2,
                                        const double x, const double y );

context:

  drawing context

x2:

  x ordinate of second control point

y2:

  y ordinate of second control point

x:

  x ordinate of termination point

y:

  y ordinate of termination point

# DrawPathCurveToSmoothRelative

## Synopsis

    void DrawPathCurveToSmoothRelative( DrawContext context, const double x2, const double y2,
                                        const double x, const double y );

## Description

DrawPathCurveToSmoothRelative() draws a cubic Bezier curve from the current point to (x,y) using relative coordinates. The first control point is assumed to be the reflection of the second control point on the previous command relative to the current point. (If there is no previous command or if the previous command was not an DrawPathCurveToAbsolute, DrawPathCurveToRelative, DrawPathCurveToSmoothAbsolute or DrawPathCurveToSmoothRelative, assume the first control point is coincident with the current point.) (x2,y2) is the second control point (i.e., the control point at the end of the curve). At the end of the command, the new current point becomes the final (x,y) coordinate pair used in the polybezier.

The format of the DrawPathCurveToSmoothRelative method is:

    void DrawPathCurveToSmoothRelative( DrawContext context, const double x2, const double y2,
                                        const double x, const double y );

context:

  drawing context

x2:

  x ordinate of second control point

y2:

  y ordinate of second control point

x:

  x ordinate of termination point

y:

  y ordinate of termination point

# DrawPathEllipticArcAbsolute

## Synopsis

    void DrawPathEllipticArcAbsolute( DrawContext context, const double rx, const double ry,
                                      const double x_axis_rotation,
                                      unsigned int large_arc_flag, unsigned int sweep_flag,
                                      const double x, const double y );

## Description

DrawPathEllipticArcAbsolute() draws an elliptical arc from the current point to (x, y) using absolute coordinates. The size and orientation of the ellipse are defined by two radii (rx, ry) and an xAxisRotation, which indicates how the ellipse as a whole is rotated relative to the current coordinate system. The center (cx, cy) of the ellipse is calculated automatically to satisfy the constraints imposed by the other parameters. largeArcFlag and sweepFlag contribute to the automatic calculations and help determine how the arc is drawn. If largeArcFlag is true then draw the larger of the available arcs. If sweepFlag is true, then draw the arc matching a clock-wise rotation.

The format of the DrawPathEllipticArcAbsolute method is:

    void DrawPathEllipticArcAbsolute( DrawContext context, const double rx, const double ry,
                                      const double x_axis_rotation,
                                      unsigned int large_arc_flag, unsigned int sweep_flag,
                                      const double x, const double y );

context:

  drawing context

rx:

  x radius

ry:

  y radius

x_axis_rotation:

  indicates how the ellipse as a whole is rotated relative to the current coordinate system

large_arc_flag:

  If non-zero (true) then draw the larger of the available arcs

sweep_flag:

  If non-zero (true) then draw the arc matching a clock-wise rotation

# DrawPathEllipticArcRelative

## Synopsis

    void DrawPathEllipticArcRelative( DrawContext context, const double rx, const double ry,
                                      const double x_axis_rotation,
                                      unsigned int large_arc_flag, unsigned int sweep_flag,
                                      const double x, const double y );

## Description

DrawPathEllipticArcRelative() draws an elliptical arc from the current point to (x, y) using relative coordinates. The size and orientation of the ellipse are defined by two radii (rx, ry) and an xAxisRotation, which indicates how the ellipse as a whole is rotated relative to the current coordinate system. The center (cx, cy) of the ellipse is calculated automatically to satisfy the constraints imposed by the other parameters. largeArcFlag and sweepFlag contribute to the automatic calculations and help determine how the arc is drawn. If largeArcFlag is true then draw the larger of the available arcs. If sweepFlag is true, then draw the arc matching a clock-wise rotation.

The format of the DrawPathEllipticArcRelative method is:

    void DrawPathEllipticArcRelative( DrawContext context, const double rx, const double ry,
                                      const double x_axis_rotation,
                                      unsigned int large_arc_flag, unsigned int sweep_flag,
                                      const double x, const double y );

context:

  drawing context

rx:

  x radius

ry:

  y radius

x_axis_rotation:

  indicates how the ellipse as a whole is rotated relative to the current coordinate system

large_arc_flag:

  If non-zero (true) then draw the larger of the available arcs

sweep_flag:

  If non-zero (true) then draw the arc matching a clock-wise rotation

# DrawPathFinish

## Synopsis

    void DrawPathFinish( DrawContext context );

## Description

DrawPathFinish() terminates the current path.

The format of the DrawPathFinish method is:

    void DrawPathFinish( DrawContext context );

A description of each parameter follows:

context:

  drawing context

# DrawPathLineToAbsolute

## Synopsis

    void DrawPathLineToAbsolute( DrawContext context, const double x, const double y );

## Description

DrawPathLineToAbsolute() draws a line path from the current point to the given coordinate using absolute coordinates. The coordinate then becomes the new current point.

The format of the DrawPathLineToAbsolute method is:

    void DrawPathLineToAbsolute( DrawContext context, const double x, const double y );

context:

  drawing context

x:

  target x ordinate

y:

  target y ordinate

# DrawPathLineToRelative

## Synopsis

    void DrawPathLineToRelative( DrawContext context, const double x, const double y );

## Description

DrawPathLineToRelative() draws a line path from the current point to the given coordinate using relative coordinates. The coordinate then becomes the new current point.

The format of the DrawPathLineToRelative method is:

    void DrawPathLineToRelative( DrawContext context, const double x, const double y );

context:

  drawing context

x:

  target x ordinate

y:

  target y ordinate

# DrawPathLineToHorizontalAbsolute

## Synopsis

    void DrawPathLineToHorizontalAbsolute( DrawContext context, const double x );

## Description

DrawPathLineToHorizontalAbsolute() draws a horizontal line path from the current point to the target point using absolute coordinates. The target point then becomes the new current point.

The format of the DrawPathLineToHorizontalAbsolute method is:

    void DrawPathLineToHorizontalAbsolute( DrawContext context, const double x );

context:

  drawing context

x:

  target x ordinate

# DrawPathLineToHorizontalRelative

## Synopsis

    void DrawPathLineToHorizontalRelative( DrawContext context, const double x );

## Description

DrawPathLineToHorizontalRelative() draws a horizontal line path from the current point to the target point using relative coordinates. The target point then becomes the new current point.

The format of the DrawPathLineToHorizontalRelative method is:

    void DrawPathLineToHorizontalRelative( DrawContext context, const double x );

A description of each parameter follows:

context:

  drawing context

x:

  target x ordinate

# DrawPathLineToVerticalAbsolute

## Synopsis

    void DrawPathLineToVerticalAbsolute( DrawContext context, const double y );

## Description

DrawPathLineToVerticalAbsolute() draws a vertical line path from the current point to the target point using absolute coordinates. The target point then becomes the new current point.

The format of the DrawPathLineToVerticalAbsolute method is:

    void DrawPathLineToVerticalAbsolute( DrawContext context, const double y );

context:

  drawing context

y:

  target y ordinate

# DrawPathLineToVerticalRelative

## Synopsis

    void DrawPathLineToVerticalRelative( DrawContext context, const double y );

## Description

DrawPathLineToVerticalRelative() draws a vertical line path from the current point to the target point using relative coordinates. The target point then becomes the new current point.

The format of the DrawPathLineToVerticalRelative method is:

    void DrawPathLineToVerticalRelative( DrawContext context, const double y );

context:

  drawing context

y:

  target y ordinate

# DrawPathMoveToAbsolute

## Synopsis

    void DrawPathMoveToAbsolute( DrawContext context, const double x, const double y );

## Description

DrawPathMoveToAbsolute() starts a new sub-path at the given coordinate using absolute coordinates. The current point then becomes the specified coordinate.

The format of the DrawPathMoveToAbsolute method is:

    void DrawPathMoveToAbsolute( DrawContext context, const double x, const double y );

context:

  drawing context

x:

  target x ordinate

y:

  target y ordinate

# DrawPathMoveToRelative

## Synopsis

    void DrawPathMoveToRelative( DrawContext context, const double x, const double y );

## Description

DrawPathMoveToRelative() starts a new sub-path at the given coordinate using relative coordinates. The current point then becomes the specified coordinate.

The format of the DrawPathMoveToRelative method is:

    void DrawPathMoveToRelative( DrawContext context, const double x, const double y );

context:

  drawing context

x:

  target x ordinate

y:

  target y ordinate

# DrawPathStart

## Synopsis

    void DrawPathStart( DrawContext context );

## Description

DrawPathStart() declares the start of a path drawing list which is terminated by a matching DrawPathFinish() command. All other DrawPath commands must be enclosed between a DrawPathStart() and a DrawPathFinish() command. This is because path drawing commands are subordinate commands and they do not function by themselves.

The format of the DrawPathStart method is:

    void DrawPathStart( DrawContext context );

A description of each parameter follows:

context:

  drawing context

# DrawPeekGraphicContext

## Synopsis

    DrawInfo *DrawPeekGraphicContext( const DrawContext context );

## Description

DrawPeekGraphicContext() returns a copy of the the DrawInfo structure at the head of the drawing context stack. The user is responsible for deallocating the returned object using DestroyDrawInfo.

The format of the DrawPeekGraphicContext method is:

    DrawInfo *DrawPeekGraphicContext( const DrawContext context );

A description of each parameter follows:

context:

  drawing context

# DrawPoint

## Synopsis

    void DrawPoint( DrawContext context, const double x, const double y );

## Description

DrawPoint() draws a point using the current stroke color and stroke thickness at the specified coordinates.

The format of the DrawPoint method is:

    void DrawPoint( DrawContext context, const double x, const double y );

A description of each parameter follows:

context:

  drawing context

x:

  target x coordinate

y:

  target y coordinate

# DrawPolygon

## Synopsis

    void DrawPolygon( DrawContext context, const unsigned long num_coords,
                      const PointInfo *coordinates );

## Description

DrawPolygon() draws a polygon using the current stroke, stroke width, and fill color or texture, using the specified array of coordinates.

The format of the DrawPolygon method is:

    void DrawPolygon( DrawContext context, const unsigned long num_coords,
                      const PointInfo *coordinates );

context:

  drawing context

num_coords:

  number of coordinates

coordinates:

  coordinate array

# DrawPolyline

## Synopsis

    void DrawPolyline( DrawContext context, const unsigned long num_coords,
                       const PointInfo *coordinates );

## Description

DrawPolyline() draws a polyline using the current stroke, stroke width, and fill color or texture, using the specified array of coordinates.

The format of the DrawPolyline method is:

    void DrawPolyline( DrawContext context, const unsigned long num_coords,
                       const PointInfo *coordinates );

context:

  drawing context

num_coords:

  number of coordinates

coordinates:

  coordinate array

# DrawPopClipPath

## Synopsis

    void DrawPopClipPath( DrawContext context );

## Description

DrawPopClipPath() terminates a clip path definition.

The format of the DrawPopClipPath method is:

    void DrawPopClipPath( DrawContext context );

A description of each parameter follows:

context:

  drawing context

# DrawPopDefs

## Synopsis

    void DrawPopDefs( DrawContext context );

## Description

DrawPopDefs() terminates a definition list

The format of the DrawPopDefs method is:

    void DrawPopDefs( DrawContext context );

A description of each parameter follows:

context:

  drawing context

# DrawPopGraphicContext

## Synopsis

    void DrawPopGraphicContext( DrawContext context );

## Description

DrawPopGraphicContext() destroys the current context returning to the previously pushed context. Multiple contexts may exist. It is an error to attempt to pop more contexts than have been pushed, and it is proper form to pop all contexts which have been pushed.

The format of the DrawPopGraphicContext method is:

    void DrawPopGraphicContext( DrawContext context );

A description of each parameter follows:

context:

  drawing context

# DrawPopPattern

## Synopsis

    void DrawPopPattern( DrawContext context );

## Description

DrawPopPattern() terminates a pattern definition.

The format of the DrawPopPattern method is:

    void DrawPopPattern( DrawContext context );

A description of each parameter follows:

context:

  drawing context

# DrawPushClipPath

## Synopsis

    void DrawPushClipPath( DrawContext context, const char *clip_path_id );

## Description

DrawPushClipPath() starts a clip path definition which is comprized of any number of drawing commands and terminated by a DrawPopClipPath() command.

The format of the DrawPushClipPath method is:

    void DrawPushClipPath( DrawContext context, const char *clip_path_id );

A description of each parameter follows:

context:

  drawing context

clip_path_id:

  string identifier to associate with the clip path for later use.

# DrawPushDefs

## Synopsis

    void DrawPushDefs( DrawContext context );

## Description

DrawPushDefs() indicates that commands up to a terminating DrawPopDefs() command create named elements (e.g. clip-paths, textures, etc.) which may safely be processed earlier for the sake of efficiency.

The format of the DrawPushDefs method is:

    void DrawPushDefs( DrawContext context );

A description of each parameter follows:

context:

  drawing context

# DrawPushGraphicContext

## Synopsis

    void DrawPushGraphicContext( DrawContext context );

## Description

DrawPushGraphicContext() clones the current drawing context to create a new drawing context. The original drawing context(s) may be returned to by invoking DrawPopGraphicContext(). The contexts are stored on a context stack. For every Pop there must have already been an equivalent Push.

The format of the DrawPushGraphicContext method is:

    void DrawPushGraphicContext( DrawContext context );

A description of each parameter follows:

context:

  drawing context

# DrawPushPattern

## Synopsis

    void DrawPushPattern( DrawContext context, const char *pattern_id, const double x,
                          const double y, const double width, const double height );

## Description

DrawPushPattern() indicates that subsequent commands up to a DrawPopPattern() command comprise the definition of a named pattern. The pattern space is assigned top left corner coordinates, a width and height, and becomes its own drawing space. Anything which can be drawn may be used in a pattern definition. Named patterns may be used as stroke or brush definitions.

The format of the DrawPushPattern method is:

    void DrawPushPattern( DrawContext context, const char *pattern_id, const double x,
                          const double y, const double width, const double height );

context:

  drawing context

pattern_id:

  pattern identification for later reference

x:

  x ordinate of top left corner

y:

  y ordinate of top left corner

width:

  width of pattern space

height:

  height of pattern space

# DrawRectangle

## Synopsis

    void DrawRectangle( DrawContext context, const double x1, const double y1, const double x2,
                        const double y2 );

## Description

DrawRectangle() draws a rectangle given two coordinates and using the current stroke, stroke width, and fill settings.

The format of the DrawRectangle method is:

    void DrawRectangle( DrawContext context, const double x1, const double y1, const double x2,
                        const double y2 );

x1:

  x ordinate of first coordinate

y1:

  y ordinate of first coordinate

x2:

  x ordinate of second coordinate

y2:

  y ordinate of second coordinate

# DrawRender

## Synopsis

    int DrawRender( const DrawContext context );

## Description

DrawRender() renders all preceding drawing commands onto the image.

The format of the DrawRender method is:

    int DrawRender( const DrawContext context );

A description of each parameter follows:

context:

  drawing context

# DrawRotate

## Synopsis

    void DrawRotate( DrawContext context, const double degrees );

## Description

DrawRotate() applies the specified rotation to the current coordinate space.

The format of the DrawRotate method is:

    void DrawRotate( DrawContext context, const double degrees );

A description of each parameter follows:

context:

  drawing context

degrees:

  degrees of rotation

# DrawRoundRectangle

## Synopsis

    void DrawRoundRectangle( DrawContext context, double x1, double y1, double x2, double y2,
                             double rx, double ry );

## Description

DrawRoundRectangle() draws a rounted rectangle given two coordinates, x & y corner radiuses and using the current stroke, stroke width, and fill settings.

The format of the DrawRoundRectangle method is:

    void DrawRoundRectangle( DrawContext context, double x1, double y1, double x2, double y2,
                             double rx, double ry );

context:

  drawing context

x1:

  x ordinate of first coordinate

y1:

  y ordinate of first coordinate

x2:

  x ordinate of second coordinate

y2:

  y ordinate of second coordinate

rx:

  radius of corner in horizontal direction

ry:

  radius of corner in vertical direction

# DrawScale

## Synopsis

    void DrawScale( DrawContext context, const double x, const double y );

## Description

DrawScale() adjusts the scaling factor to apply in the horizontal and vertical directions to the current coordinate space.

The format of the DrawScale method is:

    void DrawScale( DrawContext context, const double x, const double y );

A description of each parameter follows:

context:

  drawing context

x:

  horizontal scale factor

y:

  vertical scale factor

# DrawSkewX

## Synopsis

    void DrawSkewX( DrawContext context, const double degrees );

## Description

DrawSkewX() skews the current coordinate system in the horizontal direction.

The format of the DrawSkewX method is:

    void DrawSkewX( DrawContext context, const double degrees );

A description of each parameter follows:

context:

  drawing context

degrees:

  number of degrees to skew the coordinates

# DrawSkewY

## Synopsis

    void DrawSkewY( DrawContext context, const double degrees );

## Description

DrawSkewY() skews the current coordinate system in the vertical direction.

The format of the DrawSkewY method is:

    void DrawSkewY( DrawContext context, const double degrees );

A description of each parameter follows:

context:

  drawing context

degrees:

  number of degrees to skew the coordinates

# DrawSetStopColor

## Synopsis

    void DrawSetStopColor( DrawContext context, const PixelPacket *stop_color,
                           const double offset );

## Description

DrawSetStopColor() sets the stop color and offset for gradients

The format of the DrawSetStopColor method is:

    void DrawSetStopColor( DrawContext context, const PixelPacket *stop_color,
                           const double offset );

context:

  drawing context

o stop_color:

o offset:

# DrawGetStrokeColor

## Synopsis

    PixelPacket DrawGetStrokeColor( DrawContext context );

## Description

DrawGetStrokeColor() returns the color used for stroking object outlines.

The format of the DrawGetStrokeColor method is:

    PixelPacket DrawGetStrokeColor( DrawContext context );

A description of each parameter follows:

context:

  drawing context

# DrawSetStrokeColor

## Synopsis

    void DrawSetStrokeColor( DrawContext context, const PixelPacket *stroke_color );

## Description

DrawSetStrokeColor() sets the color used for stroking object outlines.

The format of the DrawSetStrokeColor method is:

    void DrawSetStrokeColor( DrawContext context, const PixelPacket *stroke_color );

context:

  drawing context

stroke_color:

  stroke color

# DrawSetStrokeColorString

## Synopsis

    void DrawSetStrokeColorString( DrawContext context, const char *stroke_color );

## Description

DrawSetStrokeColorString() sets the color used for stroking object outlines.

The format of the DrawSetStrokeColorString method is:

    void DrawSetStrokeColorString( DrawContext context, const char *stroke_color );

context:

  drawing context

stroke_color:

  stroke color

# DrawSetStrokePatternURL

## Synopsis

    void DrawSetStrokePatternURL( DrawContext context, const char *stroke_url );

## Description

DrawSetStrokePatternURL() sets the pattern used for stroking object outlines.

The format of the DrawSetStrokePatternURL method is:

    void DrawSetStrokePatternURL( DrawContext context, const char *stroke_url );

A description of each parameter follows:

context:

  drawing context

stroke_url:

  URL specifying pattern ID (e.g. "#pattern_id")

# DrawGetStrokeAntialias

## Synopsis

    unsigned int DrawGetStrokeAntialias( DrawContext context );

## Description

DrawGetStrokeAntialias() returns the current stroke antialias setting. Stroked outlines are antialiased by default. When antialiasing is disabled stroked pixels are thresholded to determine if the stroke color or underlying canvas color should be used.

The format of the DrawGetStrokeAntialias method is:

    unsigned int DrawGetStrokeAntialias( DrawContext context );

A description of each parameter follows:

context:

  drawing context

# DrawSetStrokeAntialias

## Synopsis

    void DrawSetStrokeAntialias( DrawContext context, const unsigned int stroke_antialias );

## Description

DrawSetStrokeAntialias() controls whether stroked outlines are antialiased. Stroked outlines are antialiased by default. When antialiasing is disabled stroked pixels are thresholded to determine if the stroke color or underlying canvas color should be used.

The format of the DrawSetStrokeAntialias method is:

    void DrawSetStrokeAntialias( DrawContext context, const unsigned int stroke_antialias );

context:

  drawing context

stroke_antialias:

  set to false (zero) to disable antialiasing

# DrawGetStrokeDashArray

## Synopsis

    double *DrawGetStrokeDashArray( DrawContext context, unsigned long *num_elems );

## Description

DrawGetStrokeDashArray() returns an array representing the pattern of dashes and gaps used to stroke paths (see DrawSetStrokeDashArray). The array must be freed once it is no longer required by the user.

The format of the DrawGetStrokeDashArray method is:

    double *DrawGetStrokeDashArray( DrawContext context, unsigned long *num_elems );

A description of each parameter follows:

context:

  drawing context

number_elements:

  address to place number of elements in dash array

# DrawSetStrokeDashArray

## Synopsis

    void DrawSetStrokeDashArray( DrawContext context, const unsigned long num_elems,
                                 const double *dasharray );

## Description

DrawSetStrokeDashArray() specifies the pattern of dashes and gaps used to stroke paths. The strokeDashArray represents an array of numbers that specify the lengths of alternating dashes and gaps in pixels. If an odd number of values is provided, then the list of values is repeated to yield an even number of values. To remove an existing dash array, pass a zero num_elems argument and null dasharray. A typical stroke dash array might contain the members 5 3 2.

The format of the DrawSetStrokeDashArray method is:

    void DrawSetStrokeDashArray( DrawContext context, const unsigned long num_elems,
                                 const double *dasharray );

context:

  drawing context

num_elems:

  number of elements in dash array

dasharray:

  dash array values

# DrawGetStrokeDashOffset

## Synopsis

    double DrawGetStrokeDashOffset( DrawContext context );

## Description

DrawGetStrokeDashOffset() returns the offset into the dash pattern to start the dash.

The format of the DrawGetStrokeDashOffset method is:

    double DrawGetStrokeDashOffset( DrawContext context );

A description of each parameter follows:

context:

  drawing context

# DrawSetStrokeDashOffset

## Synopsis

    void DrawSetStrokeDashOffset( DrawContext context, const double dash_offset );

## Description

DrawSetStrokeDashOffset() specifies the offset into the dash pattern to start the dash.

The format of the DrawSetStrokeDashOffset method is:

    void DrawSetStrokeDashOffset( DrawContext context, const double dash_offset );

context:

  drawing context

dash_offset:

  dash offset

# DrawGetStrokeLineCap

## Synopsis

    LineCap DrawGetStrokeLineCap( DrawContext context );

## Description

DrawGetStrokeLineCap() returns the shape to be used at the end of open subpaths when they are stroked. Values of LineCap are UndefinedCap, ButtCap, RoundCap, and SquareCap.

The format of the DrawGetStrokeLineCap method is:

    LineCap DrawGetStrokeLineCap( DrawContext context );

A description of each parameter follows:

context:

  drawing context

# DrawSetStrokeLineCap

## Synopsis

    void DrawSetStrokeLineCap( DrawContext context, const LineCap linecap );

## Description

DrawSetStrokeLineCap() specifies the shape to be used at the end of open subpaths when they are stroked. Values of LineCap are UndefinedCap, ButtCap, RoundCap, and SquareCap.

The format of the DrawSetStrokeLineCap method is:

    void DrawSetStrokeLineCap( DrawContext context, const LineCap linecap );

context:

  drawing context

linecap:

  linecap style

# DrawGetStrokeLineJoin

## Synopsis

    LineJoin DrawGetStrokeLineJoin( DrawContext context );

## Description

DrawGetStrokeLineJoin() returns the shape to be used at the corners of paths (or other vector shapes) when they are stroked. Values of LineJoin are UndefinedJoin, MiterJoin, RoundJoin, and BevelJoin.

The format of the DrawGetStrokeLineJoin method is:

    LineJoin DrawGetStrokeLineJoin( DrawContext context );

A description of each parameter follows:

context:

  drawing context

# DrawSetStrokeLineJoin

## Synopsis

    void DrawSetStrokeLineJoin( DrawContext context, const LineJoin linejoin );

## Description

DrawSetStrokeLineJoin() specifies the shape to be used at the corners of paths (or other vector shapes) when they are stroked. Values of LineJoin are UndefinedJoin, MiterJoin, RoundJoin, and BevelJoin.

The format of the DrawSetStrokeLineJoin method is:

    void DrawSetStrokeLineJoin( DrawContext context, const LineJoin linejoin );

A description of each parameter follows:

context:

  drawing context

linejoin:

  line join style

# DrawGetStrokeMiterLimit

## Synopsis

    unsigned long DrawGetStrokeMiterLimit( DrawContext context );

## Description

DrawGetStrokeMiterLimit() returns the miter limit. When two line segments meet at a sharp angle and miter joins have been specified for 'lineJoin', it is possible for the miter to extend far beyond the thickness of the line stroking the path. The miterLimit' imposes a limit on the ratio of the miter length to the 'lineWidth'.

The format of the DrawGetStrokeMiterLimit method is:

    unsigned long DrawGetStrokeMiterLimit( DrawContext context );

A description of each parameter follows:

context:

  drawing context

# DrawSetStrokeMiterLimit

## Synopsis

    void DrawSetStrokeMiterLimit( DrawContext context, const unsigned long miterlimit );

## Description

DrawSetStrokeMiterLimit() specifies the miter limit. When two line segments meet at a sharp angle and miter joins have been specified for 'lineJoin', it is possible for the miter to extend far beyond the thickness of the line stroking the path. The miterLimit' imposes a limit on the ratio of the miter length to the 'lineWidth'.

The format of the DrawSetStrokeMiterLimit method is:

    void DrawSetStrokeMiterLimit( DrawContext context, const unsigned long miterlimit );

context:

  drawing context

miterlimit:

  miter limit

# DrawGetStrokeOpacity

## Synopsis

    double DrawGetStrokeOpacity( DrawContext context );

## Description

DrawGetStrokeOpacity() returns the opacity of stroked object outlines.

The format of the DrawGetStrokeOpacity method is:

    double DrawGetStrokeOpacity( DrawContext context );

A description of each parameter follows:

context:

  drawing context

# DrawSetStrokeOpacity

## Synopsis

    void DrawSetStrokeOpacity( DrawContext context, const double stroke_opacity );

## Description

DrawSetStrokeOpacity() specifies the opacity of stroked object outlines.

The format of the DrawSetStrokeOpacity method is:

    void DrawSetStrokeOpacity( DrawContext context, const double stroke_opacity );

context:

  drawing context

stroke_opacity:

  stroke opacity. The value 1.0 is opaque.

# DrawGetStrokeWidth

## Synopsis

    double DrawGetStrokeWidth( DrawContext context );

## Description

DrawGetStrokeWidth() returns the width of the stroke used to draw object outlines.

The format of the DrawGetStrokeWidth method is:

    double DrawGetStrokeWidth( DrawContext context );

A description of each parameter follows:

context:

  drawing context

# DrawSetStrokeWidth

## Synopsis

    void DrawSetStrokeWidth( DrawContext context, const double stroke_width );

## Description

DrawSetStrokeWidth() sets the width of the stroke used to draw object outlines.

The format of the DrawSetStrokeWidth method is:

    void DrawSetStrokeWidth( DrawContext context, const double stroke_width );

A description of each parameter follows:

context:

  drawing context

stroke_width:

  stroke width

# DrawGetTextAntialias

## Synopsis

    unsigned int DrawGetTextAntialias( DrawContext context );

## Description

DrawGetTextAntialias() returns the current text antialias setting, which determines whether text is antialiased. Text is antialiased by default.

The format of the DrawGetTextAntialias method is:

    unsigned int DrawGetTextAntialias( DrawContext context );

A description of each parameter follows:

context:

  drawing context

# DrawSetTextAntialias

## Synopsis

    void DrawSetTextAntialias( DrawContext context, const unsigned int text_antialias );

## Description

DrawSetTextAntialias() controls whether text is antialiased. Text is antialiased by default.

The format of the DrawSetTextAntialias method is:

    void DrawSetTextAntialias( DrawContext context, const unsigned int text_antialias );

context:

  drawing context

text_antialias:

  antialias boolean. Set to false (0) to disable antialiasing.

# DrawGetTextDecoration

## Synopsis

    DecorationType DrawGetTextDecoration( DrawContext context );

## Description

DrawGetTextDecoration() returns the decoration applied when annotating with text.

The format of the DrawGetTextDecoration method is:

    DecorationType DrawGetTextDecoration( DrawContext context );

A description of each parameter follows:

context:

  drawing context

# DrawSetTextDecoration

## Synopsis

    void DrawSetTextDecoration( DrawContext context, const DecorationType decoration );

## Description

DrawSetTextDecoration() specifies a decoration to be applied when annotating with text.

The format of the DrawSetTextDecoration method is:

    void DrawSetTextDecoration( DrawContext context, const DecorationType decoration );

context:

  drawing context

decoration:

  text decoration. One of NoDecoration, UnderlineDecoration, OverlineDecoration, or LineThroughDecoration

# DrawGetTextEncoding

## Synopsis

    char *DrawGetTextEncoding( DrawContext context );

## Description

DrawGetTextEncoding() returns a null-terminated string which specifies the code set used for text annotations. The string must be freed by the user once it is no longer required.

The format of the DrawGetTextEncoding method is:

    char *DrawGetTextEncoding( DrawContext context );

A description of each parameter follows:

context:

  drawing context

# DrawSetTextEncoding

## Synopsis

    void DrawSetTextEncoding( DrawContext context, const char *encoding );

## Description

DrawSetTextEncoding() specifies specifies the code set to use for text annotations. The only character encoding which may be specified at this time is "UTF-8" for representing Unicode as a sequence of bytes. Specify an empty string to set text encoding to the system's default. Successful text annotation using Unicode may require fonts designed to support Unicode.

The format of the DrawSetTextEncoding method is:

    void DrawSetTextEncoding( DrawContext context, const char *encoding );

A description of each parameter follows:

context:

  drawing context

encoding:

  character string specifying text encoding

# DrawGetTextUnderColor

## Synopsis

    PixelPacket DrawGetTextUnderColor( DrawContext context );

## Description

DrawGetTextUnderColor() returns the color of a background rectangle to place under text annotations.

The format of the DrawGetTextUnderColor method is:

    PixelPacket DrawGetTextUnderColor( DrawContext context );

A description of each parameter follows:

context:

  drawing context

# DrawSetTextUnderColor

## Synopsis

    void DrawSetTextUnderColor( DrawContext context, const PixelPacket *under_color );

## Description

DrawSetTextUnderColor() specifies the color of a background rectangle to place under text annotations.

The format of the DrawSetTextUnderColor method is:

    void DrawSetTextUnderColor( DrawContext context, const PixelPacket *under_color );

context:

  drawing context

under_color:

  text under color

# DrawSetTextUnderColorString

## Synopsis

    void DrawSetTextUnderColorString( DrawContext context, const char *under_color );

## Description

DrawSetTextUnderColorString() specifies the color of a background rectangle to place under text annotations.

The format of the DrawSetTextUnderColorString method is:

    void DrawSetTextUnderColorString( DrawContext context, const char *under_color );

context:

  drawing context

under_color:

  text under color

# DrawTranslate

## Synopsis

    void DrawTranslate( DrawContext context, const double x, const double y );

## Description

DrawTranslate() applies a translation to the current coordinate system which moves the coordinate system origin to the specified coordinate.

The format of the DrawTranslate method is:

    void DrawTranslate( DrawContext context, const double x, const double y );

context:

  drawing context

x:

  new x ordinate for coordinate system origin

y:

  new y ordinate for coordinate system origin

# DrawSetViewbox

## Synopsis

    void DrawSetViewbox( DrawContext context, unsigned long x1, unsigned long y1,
                         unsigned long x2, unsigned long y2 );

## Description

DrawSetViewbox() sets the overall canvas size to be recorded with the drawing vector data. Usually this will be specified using the same size as the canvas image. When the vector data is saved to SVG or MVG formats, the viewbox is use to specify the size of the canvas image that a viewer will render the vector data on.

The format of the DrawSetViewbox method is:

    void DrawSetViewbox( DrawContext context, unsigned long x1, unsigned long y1,
                         unsigned long x2, unsigned long y2 );

context:

  drawing context

x1:

  left x ordinate

y1:

  top y ordinate

x2:

  right x ordinate

y2:

  bottom y ordinate

Copyright © GraphicsMagick Group 2002-2025